
/*
 * $Id: LogTagTable.h,v 1.1.1.1 1999/01/27 08:40:45 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef LOG_SYMB_TABLE_H
#define LOG_SYMB_TABLE_H

class Log;

// strict order, append-only table
typedef enum { 
	lpNone = 0,

	// special "system" types
	lpLoc,
	lpComment,
	lpSymbTable,
	lpFree = 255,

	// user types
	lpHistogram_,
	lpLineHist,
	lpLog2Hist,
	lpTimeHist,
	lpSizeHist,
	lpTimeVsSizeHist,

	lpStatPing,
	lpStatSoft,

	lpStatPhase,

	// end marker
	lpEnd
} LogEntryType;


// orderless no-delete table
typedef enum { 
	lgNone = 0,

	// special "system" tags
	lgLoc,
	lgSymbTable,
	lgComment,
	lgFree = 255,

	// user tags
	lgStatPing,
	lgStatSoft,

	lgStatPhase_,
	lgStatPhaseWarm,
	lgStatPhaseMeas,
	lgStatPhaseCool,

	// end marker
	lgEnd
} LogEntryTag;


// holds metadata about log entries
class TagDescr {
	public:
		TagDescr(LogEntryTag aTag, LogEntryType aType, const String &aName, int aVer = 0);

		void store(Log &log) const;

	public:
		LogEntryTag theTag;
		LogEntryType theType;
		String theName;
		int theVer;
};

extern void StoreSymbTable(Log &log);

#endif
